#!/usr/bin/env python3

import sys

if len(sys.argv) != 2:
    print("Input file required.")
    exit()

'''
Extended bottom-up DP solution of the 2D Jump-It game.
   board - 2D list representing playing board
   costs - 2D list to store costs
'''

# Read the game board from a given file
with open(sys.argv[1], 'r') as boardfile:
    num_rows, num_cols = tuple(int(x) for x in boardfile.readline().split())
    board = []
    for line in boardfile:
        board.append([int(v) for v in line.split()])

# Initialize costs to zero
costs = [[0 for i in range(num_cols)] for j in range(num_rows)]


"""-------------------------------------------------------------------
# 1. If you are at the exit cell, then you cannot move.
#
# |---|---|---|---|
# |---|---|---|---|
# |---|---|---|---|
# |---|---|---| X |
#
-------------------------------------------------------------------"""

# Cost of the exit cell is equal to the board at the exit cell
# TODO



"""-------------------------------------------------------------------
# 2. If you are 1 cell to the left of the exit cell, then your only
#    choice is to move right (into the exit cell).
#
# |---|---|---|---|
# |---|---|---|---|
# |---|---|---|---|
# |---|---| X |---|
#
-------------------------------------------------------------------"""

# Cost is equal to the board at the the current cell + exit cell
# TODO



"""-------------------------------------------------------------------
# 3. If you are 1 cell above the exit cell, then your only choice is
#    to move down (into the exit cell).
#
# |---|---|---|---|
# |---|---|---|---|
# |---|---|---| X |
# |---|---|---|---|
#
-------------------------------------------------------------------"""

# Cost is equal to the board at the the current cell + exit cell
# TODO



"""-------------------------------------------------------------------
# 4. If you are 1 cell above and 1 cell to the left of the exit cell
#    (the diagonal cell), then you have two choice:
#       (a) go down and then right, or
#       (b) go right and then down.
#
# |---|---|---|---|
# |---|---|---|---|
# |---|---| X |---|
# |---|---|---|---|
#
-------------------------------------------------------------------"""

# Cost is equal to the exit cell + the minimum of the two choices
# TODO



"""-------------------------------------------------------------------
# 5. If you are in the last row (and not at the exit cell or the cell
#    to the left of the exit cell) then you need to consider two
#    choices:
#       (a) go right, or
#       (b) jump right.
#    You should fill in these values starting at the cell 2 to the
#    left of the exit cell, working your way to the first cell in the
#    last row.
#
# |---|---|---|---|
# |---|---|---|---|
# |---|---|---|---|
# | X | X |---|---|
#
-------------------------------------------------------------------"""

# Fill in the rest of the last row using the recurrence formula
# TODO



"""-------------------------------------------------------------------
# 6. If you are in the last column (and not at the exit cell or the
#    cell above the exit cell) then you need to consider two choices:
#       (a) go down, or
#       (b) jump down.
#    You should fill these values in starting at the cell 2 above the
#    exit cell, working your way to the first cell in the last
#    column.
#
# |---|---|---| X |
# |---|---|---| X |
# |---|---|---|---|
# |---|---|---|---|
#
-------------------------------------------------------------------"""

# Fill in the rest of last column using the recurrence formula
# TODO



"""-------------------------------------------------------------------
# 7. If you are in the second-to-last row (and not at the diagonal
#    cell or the last cell in the row), then you need to consider
#    three choices:
#       (a) go down,
#       (b) go right, or
#       (c) jump right.
#
# |---|---|---|---|
# |---|---|---|---|
# | X | X |---|---|
# |---|---|---|---|
#
-------------------------------------------------------------------"""

# TODO



"""-------------------------------------------------------------------
# 8. If you are in the second-to-last column (and not at the diagonal
#    cell or the last cell in the column), then you need to consider
#    three choices:
#       (a) go right,
#       (b) go down, or
#       (c) jump down.
#
# |---|---| X |---|
# |---|---| X |---|
# |---|---|---|---|
# |---|---|---|---|
#
-------------------------------------------------------------------"""

# TODO



"""-------------------------------------------------------------------
# 9. Finally, for all other cells you must consider four cases:
#       (a) go right,
#       (b) jump right,
#       (c) go down, or
#       (d) jump down.
#
# | X | X |---|---|
# | X | X |---|---|
# |---|---|---|---|
# |---|---|---|---|
#
-------------------------------------------------------------------"""

# TODO




"""-------------------------------------------------------------------
# Print
-------------------------------------------------------------------"""

print('\n'.join(' '.join(f'{val:2}' for val in row) for row in costs))
